NOTICE_TITLE_XPATH = """//x:FORM_SECTION/*[@LG='{lang}']/x:OBJECT_CONTRACT/x:TITLE/x:P/text() 
| //x:CONTRACT[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:CONTRACT_AWARD[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:PRIOR_INFORMATION[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:SIMPLIFIED_CONTRACT[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:CONTRACT_AWARD_DEFENCE[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:PRIOR_INFORMATION_DEFENCE[@LG='{lang}']//x:TITLE_CONTRACT/x:P/text()
| //x:OTH_NOT[@LG='{lang}']//x:TI_DOC/x:P/text()"""

LANGUAGE_NOTICE_XPATH = "//x:LG_ORIG/text()"

SHORT_DESC_XPATH = """//x:FORM_SECTION/*[@LG='{lang}']//x:SHORT_DESCR/x:P/text() 
| //x:CONTRACT_AWARD[@LG='{lang}']//x:SHORT_CONTRACT_DESCRIPTION/x:P/text()
| //x:CONTRACT[@LG='{lang}']//x:SHORT_CONTRACT_DESCRIPTION/x:P/text()
| //x:CONTRACT_AWARD_DEFENCE[@LG='{lang}']//x:SHORT_CONTRACT_DESCRIPTION/x:P/text()
| //x:PRIOR_INFORMATION[@LG='{lang}']//x:TOTAL_QUANTITY_OR_SCOPE/x:P/text()
| //x:PRIOR_INFORMATION_DEFENCE[@LG='{lang}']//x:TOTAL_QUANTITY_OR_SCOPE/x:P/text()
| //x:SIMPLIFIED_CONTRACT[@LG='{lang}']//x:SHORT_DESCRIPTION_CONTRACT/x:P/text()"""
MAIN_CPV_XPATH = """
//x:CONTRACT[@LG='{lang}']//x:DESCRIPTION_CONTRACT_INFORMATION/x:CPV/x:CPV_MAIN/x:CPV_CODE/@CODE
| //x:ORIGINAL_CPV/@CODE"""

NOTICE_ID_XPATH = "//x:NOTICE_DATA/x:NO_DOC_OJS/text()"
PUB_DATE_XPATH = "//x:CODED_DATA_SECTION/x:REF_OJS/x:DATE_PUB/text()"
REF_NOTICE_ID_XPATH = "//x:REF_NOTICE/x:NO_DOC_OJS/text()"
ADDITIONAL_CPVS_XPATH = """//x:CONTRACT//x:DESCRIPTION_CONTRACT_INFORMATION/
                            x:CPV/x:CPV_ADDITIONAL/x:CPV_CODE/@CODE
                            | //x:ORIGINAL_CPV/@CODE"""
CONTRACT_TYPE_XPATH = "//x:NC_CONTRACT_NATURE/text()"
NOTICE_VERSION_XPATH = [
    "//x:TED_EXPORT/@VERSION",
    "//x:FORM_SECTION/x:OTH_NOT/@VERSION",
    "//x:FORM_SECTION/x:CONTRACT/@VERSION",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION/@VERSION",
    "//x:FORM_SECTION/x:CONTRACT_AWARD/@VERSION",
    "//x:FORM_SECTION/x:SIMPLIFIED_CONTRACT/@VERSION"
]
NOTICE_TYPE_XPATH = "//x:TD_DOCUMENT_TYPE/text()"
ETENDERING_URL_XPATH = "//x:IA_URL_ETENDERING/text()"
UNSUCCESSFUL_PROCUREMENT_XPATH = "//x:AWARD_CONTRACT//x:PROCUREMENT_UNSUCCESSFUL"
DISCONTINUED_PROCUREMENT_XPATH = "//x:AWARD_CONTRACT//x:PROCUREMENT_DISCONTINUED"
LOT_R208_XPATH = "//x:CONTRACT_AWARD[@LG='EN']//x:AWARD_OF_CONTRACT"
LOT_R209_XPATH = [
    "//x:F01_2014[@LG='EN']//x:AWARD_CONTRACT",
    "//x:F02_2014[@LG='EN']//x:AWARD_CONTRACT",
    "//x:F03_2014[@LG='EN']//x:AWARD_CONTRACT",
]
AWARDED_COMPANIES_R208_XPATH = ".//x:ECONOMIC_OPERATOR_NAME_ADDRESS"
AWARDED_COMPANIES_R209_XPATH = ".//x:AWARDED_CONTRACT//x:CONTRACTOR//x:ADDRESS_CONTRACTOR"
COMPANY_NAME_XPATH = ".//x:OFFICIALNAME/text()"
COMPANY_NATIONAL_ID_XPATH = ".//x:NATIONALID/text()"
COMPANY_TOWN_XPATH = ".//x:TOWN/text()"
COMPANY_ADDRESS_XPATH = ".//x:ADDRESS/text()"
COMPANY_POSTAL_CODE_XPATH = ".//x:POSTAL_CODE/text()"
COMPANY_COUNTRY_XPATH = ".//x:COUNTRY/@VALUE"
COMPANY_PHONE_XPATH = ".//x:PHONE/text()"
COMPANY_EMAIL_XPATH = ".//x:E_MAIL/text()"
COMPANY_WEBSITE_XPATH = ".//x:URL/text()"
BUDGET_LOTS_XPATH = """//x:FORM_SECTION/*[@LG = '{lang}']//x:LOT_NO/text() 
    | //x:FORM_SECTION/*[@LG = '{lang}']//x:LOT_NUMBER/text()"""
LANGUAGES = ["EN", "FR", "BG", "ES", "CS", "DA", "DE", "ET", "EL", "GA", "HR", "IT", "LV", "LT", "HU", "MT", "NL",
             "PL", "PT", "RO", "SK", "SL", "FI", "SV"]
ESTIMATED_VALUE_XPATH = """//x:OBJECT_CONTRACT/x:VAL_ESTIMATED_TOTAL/text()
    | //x:OBJECT_CONTRACT/x:OBJECT_DESCR[not(x:LOT_NO)]/x:VAL_OBJECT/text()
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_ESTIMATED_TOTAL/text()
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_ESTIMATED_TOTAL/text()"""
LOT_ESTIMATED_VALUE_XPATH = """//x:OBJECT_CONTRACT/x:OBJECT_DESCR[x:LOT_NO/text() = {lot}]/x:VAL_OBJECT/text()
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_ESTIMATED_TOTAL/text()
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_ESTIMATED_TOTAL/text()"""
ESTIMATED_VALUE_CURRENCY_XPATH = """//x:OBJECT_CONTRACT/x:VAL_ESTIMATED_TOTAL/@CURRENCY
    | //x:OBJECT_CONTRACT/x:OBJECT_DESCR[not(x:LOT_NO)]/x:VAL_OBJECT/@CURRENCY
    | //x:AWARD_CONTRACT[not(LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_ESTIMATED_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[not(LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_ESTIMATED_TOTAL/@CURRENCY"""
LOT_ESTIMATED_VALUE_CURRENCY_XPATH = """//x:OBJECT_CONTRACT/x:OBJECT_DESCR[x:LOT_NO/text() = {lot}]/x:VAL_OBJECT/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_ESTIMATED_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_ESTIMATED_TOTAL/@CURRENCY"""
MIN_VALUE_XPATH = """//x:OBJECT_CONTRACT/x:VAL_TOTAL/text()
    | //x:OBJECT_CONTRACT/x:VAL_RANGE_TOTAL/x:LOW/text()
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/x:RANGE_VALUE_COST/x:LOW_VALUE/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/x:RANGE_VALUE_COST/x:LOW_VALUE/@FMTVAL
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/text()
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_TOTAL/text()"""
LOT_MIN_VALUE_XPATH = """//x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/x:RANGE_VALUE_COST/x:LOW_VALUE/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/x:RANGE_VALUE_COST/x:LOW_VALUE/@FMTVAL
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/text()
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_TOTAL/text()"""
MIN_VALUE_CURRENCY_XPATH = """//x:OBJECT_CONTRACT/x:VAL_TOTAL/@CURRENCY
    | //x:OBJECT_CONTRACT/x:VAL_RANGE_TOTAL/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/@CURRENCY
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_TOTAL/@CURRENCY"""
LOT_MIN_VALUE_CURRENCY_XPATH = """//x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_TOTAL/@CURRENCY"""
MAX_VALUE_XPATH = """//x:OBJECT_CONTRACT/x:VAL_TOTAL/text()
    | //x:OBJECT_CONTRACT/x:VAL_RANGE_TOTAL/x:HIGH/text()
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/x:RANGE_VALUE_COST/x:HIGH_VALUE/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/x:RANGE_VALUE_COST/x:HIGH_VALUE/@FMTVAL
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/text()
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_TOTAL/text()"""
LOT_MAX_VALUE_XPATH = """//x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/x:RANGE_VALUE_COST/x:HIGH_VALUE/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/x:VALUE_COST/@FMTVAL
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/x:RANGE_VALUE_COST/x:HIGH_VALUE/@FMTVAL
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/text()
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_TOTAL/text()"""
MAX_VALUE_CURRENCY_XPATH = """//x:OBJECT_CONTRACT/x:VAL_TOTAL/@CURRENCY 
    | //x:OBJECT_CONTRACT/x:VAL_RANGE_TOTAL/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY[not(../../x:LOT_NUMBER)]/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[not(../../x:LOT_NUMBER)]/@CURRENCY
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[not(x:LOT_NO)]/x:AWARDED_CONTRACT/x:VAL_TOTAL/@CURRENCY"""
LOT_MAX_VALUE_CURRENCY_XPATH = """//x:COSTS_RANGE_AND_CURRENCY[../../x:LOT_NUMBER/text() = {lot}]/@CURRENCY
    | //x:COSTS_RANGE_AND_CURRENCY_WITH_VAT_RATE[../../x:LOT_NUMBER/text() = {lot}]/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VALUES/x:VAL_TOTAL/@CURRENCY
    | //x:AWARD_CONTRACT[x:LOT_NO/text() = {lot}]/x:AWARDED_CONTRACT/x:VAL_TOTAL/@CURRENCY"""
BUYER_NAME_XPATH = """//x:FORM_SECTION/*[@LG='{lang}']/x:CONTRACTING_BODY/x:ADDRESS_CONTRACTING_BODY/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:OTH_NOT[@LG='{lang}']//x:ADDRESS_NOT_STRUCT/x:ORGANISATION/text()
    | //x:FORM_SECTION/x:PRIOR_INFORMATION[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:ORGANISATION/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:CONTRACT[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_CONTRACT//x:ORGANISATION/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:CONTRACT_AWARD[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:ORGANISATION/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:SIMPLIFIED_CONTRACT[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_SIMPLIFIED_CONTRACT//x:ORGANISATION/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:PRIOR_INFORMATION_DEFENCE[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:ORGANISATION/x:OFFICIALNAME/text()
    | //x:FORM_SECTION/x:CONTRACT_AWARD_DEFENCE[@LG='{lang}']//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:ORGANISATION/x:OFFICIALNAME/text()"""
BUYER_ADDRESS_XPATH = [
    "//x:FORM_SECTION/*/x:CONTRACTING_BODY/x:ADDRESS_CONTRACTING_BODY/x:ADDRESS/text()",
    "//x:FORM_SECTION/x:OTH_NOT//x:ADDRESS_NOT_STRUCT/x:ADDRESS/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:ADDRESS/text()",
    "//x:FORM_SECTION/x:CONTRACT//x:NAME_ADDRESSES_CONTACT_CONTRACT//x:ADDRESS/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:ADDRESS/text()",
    "//x:FORM_SECTION/x:SIMPLIFIED_CONTRACT//x:NAME_ADDRESSES_CONTACT_SIMPLIFIED_CONTRACT//x:ADDRESS/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION_DEFENCE//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:ADDRESS/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD_DEFENCE//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:ADDRESS/text()"
]
BUYER_TOWN_XPATH = [
    "//x:FORM_SECTION/*/x:CONTRACTING_BODY/x:ADDRESS_CONTRACTING_BODY/x:TOWN/text()",
    "//x:FORM_SECTION/x:OTH_NOT//x:ADDRESS_NOT_STRUCT/x:TOWN/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:TOWN/text()",
    "//x:FORM_SECTION/x:CONTRACT//x:NAME_ADDRESSES_CONTACT_CONTRACT//x:TOWN/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:TOWN/text()",
    "//x:FORM_SECTION/x:SIMPLIFIED_CONTRACT//x:NAME_ADDRESSES_CONTACT_SIMPLIFIED_CONTRACT//x:TOWN/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION_DEFENCE//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:TOWN/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD_DEFENCE//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:TOWN/text()"

]
BUYER_POSTAL_CODE_XPATH = [
    "//x:FORM_SECTION/*/x:CONTRACTING_BODY/x:ADDRESS_CONTRACTING_BODY/x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:OTH_NOT//x:ADDRESS_NOT_STRUCT/x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:CONTRACT//x:NAME_ADDRESSES_CONTACT_CONTRACT//x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:SIMPLIFIED_CONTRACT//x:NAME_ADDRESSES_CONTACT_SIMPLIFIED_CONTRACT//x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION_DEFENCE//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:POSTAL_CODE/text()",
    "//x:FORM_SECTION/x:CONTRACT_AWARD_DEFENCE//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:POSTAL_CODE/text()"
]
COUNTRY_ISO_2_XPATH = [
    "//x:FORM_SECTION/*/x:CONTRACTING_BODY/x:ADDRESS_CONTRACTING_BODY/x:COUNTRY/@VALUE",
    "//x:CODED_DATA_SECTION/x:NOTICE_DATA/x:ISO_COUNTRY/@VALUE",
    "//x:FORM_SECTION//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:COUNTRY/@VALUE",
    "//x:FORM_SECTION//x:NAME_ADDRESSES_CONTACT_CONTRACT//x:COUNTRY/@VALUE",
    "//x:FORM_SECTION//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:COUNTRY/@VALUE",
    "//x:FORM_SECTION//x:NAME_ADDRESSES_CONTACT_SIMPLIFIED_CONTRACT//x:COUNTRY/@VALUE",
    "//x:FORM_SECTION/x:PRIOR_INFORMATION_DEFENCE//x:NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION//x:COUNTRY/@VALUE",
    "//x:FORM_SECTION/x:CONTRACT_AWARD_DEFENCE//x:NAME_ADDRESSES_CONTACT_CONTRACT_AWARD//x:COUNTRY/@VALUE"
]
BUYER_TYPE_XPATH = "//x:FORM_SECTION/*/x:CONTRACTING_BODY/x:CA_TYPE/@VALUE"

REGULATION_CODE_XPATH = "//x:CODED_DATA_SECTION/x:CODIF_DATA/x:RP_REGULATION/@CODE"
